<?php

namespace common\modules\rubrication\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use common\modules\rubrication\models\TaxOption;

/**
 * TaxOptionSearch represents the model behind the search form about `common\modules\rubrication\models\TaxOption`.
 */
class TaxOptionSearch extends TaxOption
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['tax_option_id', 'tax_group_id', 'parent_id', 'sort'], 'integer'],
            [['alias', 'value'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = TaxOption::find();
        // add conditions that should always apply here
        if (!empty($params['group'])) {
            $this->tax_group_id = intval($params['group']);
            unset($params['group']);
        }

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

//        if (!$this->validate()) {
//            return $dataProvider;
//        }

        // grid filtering conditions
        $query->andFilterWhere([
            'tax_option_id' => $this->tax_option_id,
            'tax_group_id' => $this->tax_group_id,
            'parent_id' => $this->parent_id,
            'sort' => $this->sort,
        ]);

        $query->andFilterWhere(['like', 'alias', $this->alias]);
        $query->andFilterWhere(['like', 'tax_value_string.value', $this->default_value]);

        $query->orderBy(['path_int' => SORT_ASC, 'depth' => SORT_ASC, 'sort' => SORT_ASC]);

        return $dataProvider;
    }
}
